import es, gamethread, playerlib, re, os, random, usermsg

### Globals ###

info = es.AddonInfo() 
info['name']        = "Unnamed Abuser" 
info['version']     = "3.0.0" 
info['author']      = "Bonbon AKA: Bonbon367" 
info['url']         = "http://addons.eventscripts.com/addons/view/unnamedkick" 
info['description'] = "Get rid of pesky unnamed players"

MENUFORMAT = 'WARNING:\n   You have joined without a name\n   Change it or be punished\n1. Press Escape\n2. Go to options\n3. In the box called "name" enter your name'

options = {
	'unnamed_mode': 'kick',
	'unnamed_kick_after': 360,
	'unnamed_namechange': 'Nub sawce',
	'unnamed_kick_message': 'Come back when you change your name, nub'
}

sv = es.ServerVar
unnamed = []

### Loads ###

def load():
	for option in options:
		sv(option).set(options[option])

	if os.path.isfile(es.getAddonPath('unnamedabuser') + '/unnamedabuser.cfg'):
		es.server.cmd('es_xmexec ../addons/eventscripts/unnamedabuser/unnamedabuser.cfg')

	for userid in es.getUseridList():
		player_activate({'userid': str(userid), 'es_username': es.getplayername(userid)})

def unload():
	stopDelays()

### Events ###

def player_activate(ev):
	userid = ev['userid']
	if re.match('(\([0-9]\))?unnamed$', ev['es_username']):
		unnamed.append(userid)

	if str(sv('unnamed_mode')) == 'kick' and userid in unnamed:
		es.tell(userid, '#multi', '#lightgreen[Unnamed Abuser]: #defaultYou will be kicked in #lightgreen%s:%02i (M:S)'%divmod(int(sv('unnamed_kick_after')), 60))
		gamethread.delayedname(int(sv('unnamed_kick_after')), 'kick %s'%userid, es.server.queuecmd, 'kickid %s %s'%(userid, str(sv('unnamed_kick_message'))))

def player_spawn(ev):
	userid = ev['userid']
	if userid in unnamed:
		es.menu(0, userid, MENUFORMAT)

		if str(sv('unnamed_mode')) == 'abuse':
			player = playerlib.getPlayer(userid)
			player.set('health', 144)
			player.set('speed', 0.5)

			gamethread.delayedname(10, 'slap %s'%userid, slapPlayer, userid)
			gamethread.delayedname(20, 'shake %s'%userid, usermsg.shake, (userid, 20, 60))
			gamethread.delayedname(30, 'fade %s'%userid, usermsg.fade, (userid, 2, 10000, 10000, 255, 0, 0, 200))
			gamethread.delayedname(40, 'strip %s'%userid, es.server.queuecmd, 'es_xgive %s player_weaponstrip;es_xfire %s player_weaponstrip strip;es_xfire %s player_weaponstrip kill'%(userid, userid, userid))
			gamethread.delayedname(50, 'freeze %s'%userid, player.set, ('freeze', 1))
			gamethread.delayedname(50, 'fade %s'%userid, usermsg.fade, (userid, 1, 10000, 10000, 255, 0, 0, 200))
			gamethread.delayedname(60, 'burn %s'%userid, es.server.queuecmd, 'es_xfire %s !self ignite'%userid)
			gamethread.delayedname(90, 'explode %s'%userid, es.server.queuecmd, 'es_xgive %s env_explosion;es_xfire %s env_explosion addoutput "iMagnitude 4";es_xfire %s env_explosion addoutput "iRadiusOverride 100";es_xfire %s env_explosion explode;es_xfire %s env_explosion kill'%((userid,) * 5))

		elif str(sv('unnamed_mode')) == 'changename':
			es.cexec(userid, 'name %s'%str(sv('unnamed_namechange')))

def player_disconnect(ev):
	stopDelays(ev['userid'])

def player_changename(ev):
	userid = ev['userid']
	if re.match('(\([0-9]\))?unnamed$', ev['oldname']):
		if userid in unnamed:
			unnamed.remove(userid)
		stopDelays(userid)

	if re.match('(\([0-9]\))?unnamed$', ev['newname']):
		unnamed.append(userid)
		es.menu(0, userid, MENUFORMAT)

		if str(sv('unnamed_mode')) == 'kick' and userid in unnamed:
			es.tell(userid, '#multi', '#lightgreen[Unnamed Abuser]: #defaultYou will be kicked in #lightgreen%s:%02i (M:S)'%divmod(int(sv('unnamed_kick_after')), 60))
			gamethread.delayedname(int(sv('unnamed_kick_after')), 'kick %s'%userid, es.server.queuecmd, 'kickid %s %s'%(userid, str(sv('unnamed_kick_message'))))

def round_end(ev):
	for userid in unnamed:
		stopDelays(userid)

### Misc ###

def stopDelays(userid=None):
	for userid in es.getUseridList() if not userid else [userid]:
		for delay in ['burn', 'freeze', 'strip', 'slap', 'fade', 'shake', 'slow', 'kick']:
			gamethread.cancelDelayed('%s %s'%(delay, userid))

def slapPlayer(userid):
	for d in range(10):
		gamethread.delayed(d / 10.0, es.setplayerprop, (userid, 'CCSPlayer.baseclass.localdata.m_vecBaseVelocity', ','.join([str(random.randint(x, 255)) for x in [-255, -255, 0]])))
